package examen;

@javax.ejb.Stateful(mappedName = "Loto")
public class Tirer_tous_les_chiffres implements Loto {

    /* On cherche à tirer 48 numéros, soit 8 grilles de loto où figurent dans chacune 6 numéros. 
     L'idée est de tirer 48 numéros différents parmi 49 pour maximiser nos chances. */
    private static int _Borne = 48;
    private int[] _resultat_tirage = new int[_Borne];

    @javax.ejb.EJB
    private Tirer_un_chiffre _tirer_un_chiffre;

    public void stocker() {
        // On stocke le résultat du tirage dans une base de données via des 'Entity Beans'...
        for (int i = 0; i < _Borne; i++) {
            System.out.print("\t" + _resultat_tirage[i]);
        }
    }

    public void tirer() {
        for (int i = 0; i < _Borne; i++) {
            _resultat_tirage[i] = _tirer_en_interne(i);
        }
    }

    private int _tirer_en_interne(final int i) {
        int resultat = _tirer_un_chiffre.tirer(_Borne + 1);
        boolean deja_tire = false; // On fait l'hypothèse que ce nombre n'a pas encore été tiré...
        for (int j = 0; j < i; j++) { // On regarde le début du tableau pour vérifier ce qui a déjà été tiré...
            if (resultat == _resultat_tirage[j]) { // Si déjà tiré...
                deja_tire = true;
                break; // On arrête brutalement la boucle 'for', inutile d'aller plus loin...
            }
        }
        if (deja_tire) {
            return _tirer_en_interne(i); // On recommence le tirage
        }
        return resultat; // Sinon, c'est bon
    }
}
